/* ssh-display.c generated by valac 0.48.2, the Vala compiler
 * generated from ssh-display.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/

#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "common.h"
#include <stdlib.h>
#include <string.h>
#include <vte/vte.h>
#include <libxml/uri.h>

#define BOXES_TYPE_IPROPERTIES_PROVIDER (boxes_iproperties_provider_get_type ())
#define BOXES_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProvider))
#define BOXES_IS_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER))
#define BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProviderIface))

typedef struct _BoxesIPropertiesProvider BoxesIPropertiesProvider;
typedef struct _BoxesIPropertiesProviderIface BoxesIPropertiesProviderIface;
typedef enum  {
	BOXES_PROPERTIES_PAGE_GENERAL,
	BOXES_PROPERTIES_PAGE_SYSTEM,
	BOXES_PROPERTIES_PAGE_DEVICES,
	BOXES_PROPERTIES_PAGE_SNAPSHOTS,
	BOXES_PROPERTIES_PAGE_LAST
} BoxesPropertiesPage;

#define BOXES_TYPE_PROPERTIES_PAGE (boxes_properties_page_get_type ())

#define BOXES_TYPE_PROPERTY (boxes_property_get_type ())
#define BOXES_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_PROPERTY, BoxesProperty))
#define BOXES_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_PROPERTY, BoxesPropertyClass))
#define BOXES_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_PROPERTY))
#define BOXES_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_PROPERTY))
#define BOXES_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_PROPERTY, BoxesPropertyClass))

typedef struct _BoxesProperty BoxesProperty;
typedef struct _BoxesPropertyClass BoxesPropertyClass;

#define BOXES_TYPE_DISPLAY (boxes_display_get_type ())
#define BOXES_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_DISPLAY, BoxesDisplay))
#define BOXES_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_DISPLAY, BoxesDisplayClass))
#define BOXES_IS_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_DISPLAY))
#define BOXES_IS_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_DISPLAY))
#define BOXES_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_DISPLAY, BoxesDisplayClass))

typedef struct _BoxesDisplay BoxesDisplay;
typedef struct _BoxesDisplayClass BoxesDisplayClass;
typedef struct _BoxesDisplayPrivate BoxesDisplayPrivate;
typedef gint (*BoxesDisplayOpenFDFunc) (gpointer user_data);

#define BOXES_TYPE_SSH_DISPLAY (boxes_ssh_display_get_type ())
#define BOXES_SSH_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplay))
#define BOXES_SSH_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplayClass))
#define BOXES_IS_SSH_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_SSH_DISPLAY))
#define BOXES_IS_SSH_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_SSH_DISPLAY))
#define BOXES_SSH_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplayClass))

typedef struct _BoxesSshDisplay BoxesSshDisplay;
typedef struct _BoxesSshDisplayClass BoxesSshDisplayClass;
typedef struct _BoxesSshDisplayPrivate BoxesSshDisplayPrivate;
enum  {
	BOXES_SSH_DISPLAY_0_PROPERTY,
	BOXES_SSH_DISPLAY_PROTOCOL_PROPERTY,
	BOXES_SSH_DISPLAY_URI_PROPERTY,
	BOXES_SSH_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* boxes_ssh_display_properties[BOXES_SSH_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _xmlFreeURI0(var) ((var == NULL) ? NULL : (var = (xmlFreeURI (var), NULL)))

struct _BoxesIPropertiesProviderIface {
	GTypeInterface parent_iface;
	GList* (*get_properties) (BoxesIPropertiesProvider* self, BoxesPropertiesPage page);
};

struct _BoxesDisplay {
	GObject parent_instance;
	BoxesDisplayPrivate * priv;
	gboolean connected;
	GHashTable* displays;
};

struct _BoxesDisplayClass {
	GObjectClass parent_class;
	GtkWidget* (*get_display) (BoxesDisplay* self, gint n);
	GdkPixbuf* (*get_pixbuf) (BoxesDisplay* self, gint n, GError** error);
	void (*set_enable_audio) (BoxesDisplay* self, gboolean enable);
	gboolean (*should_keep_alive) (BoxesDisplay* self);
	void (*connect_it) (BoxesDisplay* self, BoxesDisplayOpenFDFunc open_fd, gpointer open_fd_target, GDestroyNotify open_fd_target_destroy_notify, GError** error);
	void (*disconnect_it) (BoxesDisplay* self);
	void (*collect_logs) (BoxesDisplay* self, GString* builder);
	void (*transfer_files) (BoxesDisplay* self, GList* uris);
	void (*send_keys) (BoxesDisplay* self, guint* keyvals, gint keyvals_length1);
	GList* (*get_properties) (BoxesDisplay* self, BoxesPropertiesPage page);
	const gchar* (*get_protocol) (BoxesDisplay* self);
	gchar* (*get_uri) (BoxesDisplay* self);
	gboolean (*get_can_transfer_files) (BoxesDisplay* self);
};

struct _BoxesSshDisplay {
	BoxesDisplay parent_instance;
	BoxesSshDisplayPrivate * priv;
};

struct _BoxesSshDisplayClass {
	BoxesDisplayClass parent_class;
};

struct _BoxesSshDisplayPrivate {
	VteTerminal* display;
	gchar* host;
	gchar* user;
	gint port;
	BoxesBoxConfigSavedProperty* saved_properties;
	gint saved_properties_length1;
	gint _saved_properties_size_;
};

static gint BoxesSshDisplay_private_offset;
static gpointer boxes_ssh_display_parent_class = NULL;

GType boxes_properties_page_get_type (void) G_GNUC_CONST;
GType boxes_property_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoxesProperty, g_object_unref)
GType boxes_iproperties_provider_get_type (void) G_GNUC_CONST;
GType boxes_display_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoxesDisplay, g_object_unref)
GType boxes_ssh_display_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoxesSshDisplay, g_object_unref)
static void _vala_BoxesBoxConfigSavedProperty_array_free (BoxesBoxConfigSavedProperty * array,
                                                   gint array_length);
BoxesSshDisplay* boxes_ssh_display_new (BoxesBoxConfig* config,
                                        const gchar* host,
                                        gint port,
                                        const gchar* user);
BoxesSshDisplay* boxes_ssh_display_construct (GType object_type,
                                              BoxesBoxConfig* config,
                                              const gchar* host,
                                              gint port,
                                              const gchar* user);
BoxesDisplay* boxes_display_construct (GType object_type);
void boxes_display_set_config (BoxesDisplay* self,
                               BoxesBoxConfig* value);
BoxesSshDisplay* boxes_ssh_display_new_with_uri (BoxesBoxConfig* config,
                                                 const gchar* _uri,
                                                 GError** error);
BoxesSshDisplay* boxes_ssh_display_construct_with_uri (GType object_type,
                                                       BoxesBoxConfig* config,
                                                       const gchar* _uri,
                                                       GError** error);
static GtkWidget* boxes_ssh_display_real_get_display (BoxesDisplay* base,
                                               gint n);
static void boxes_ssh_display_real_set_enable_audio (BoxesDisplay* base,
                                              gboolean enable);
static GdkPixbuf* boxes_ssh_display_real_get_pixbuf (BoxesDisplay* base,
                                              gint n,
                                              GError** error);
static gboolean boxes_ssh_display_run (BoxesSshDisplay* self,
                                gchar** command,
                                gint command_length1);
static void boxes_ssh_display_real_connect_it (BoxesDisplay* base,
                                        BoxesDisplayOpenFDFunc open_fd,
                                        gpointer open_fd_target,
                                        GDestroyNotify open_fd_target_destroy_notify,
                                        GError** error);
static void boxes_ssh_display_real_disconnect_it (BoxesDisplay* base);
static GList* boxes_ssh_display_real_get_properties (BoxesDisplay* base,
                                              BoxesPropertiesPage page);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void boxes_ssh_display_real_send_keys (BoxesDisplay* base,
                                       guint* keyvals,
                                       gint keyvals_length1);
static GObject * boxes_ssh_display_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _boxes_ssh_display___lambda88_ (BoxesSshDisplay* self);
void boxes_display_access_start (BoxesDisplay* self);
static void __boxes_ssh_display___lambda88__gtk_widget_show (GtkWidget* _sender,
                                                      gpointer self);
static void boxes_ssh_display_finalize (GObject * obj);
static GType boxes_ssh_display_get_type_once (void);
const gchar* boxes_display_get_protocol (BoxesDisplay* self);
gchar* boxes_display_get_uri (BoxesDisplay* self);
static void _vala_boxes_ssh_display_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
boxes_ssh_display_get_instance_private (BoxesSshDisplay* self)
{
	return G_STRUCT_MEMBER_P (self, BoxesSshDisplay_private_offset);
}

static void
_vala_BoxesBoxConfigSavedProperty_array_free (BoxesBoxConfigSavedProperty * array,
                                              gint array_length)
{
	if (array != NULL) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			boxes_box_config_saved_property_destroy (&array[i]);
		}
	}
	g_free (array);
}

BoxesSshDisplay*
boxes_ssh_display_construct (GType object_type,
                             BoxesBoxConfig* config,
                             const gchar* host,
                             gint port,
                             const gchar* user)
{
	BoxesSshDisplay * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	VteTerminal* _tmp2_;
	BoxesBoxConfigSavedProperty* _tmp3_;
	gint _tmp3__length1;
	g_return_val_if_fail (config != NULL, NULL);
	g_return_val_if_fail (host != NULL, NULL);
	g_return_val_if_fail (user != NULL, NULL);
	self = (BoxesSshDisplay*) boxes_display_construct (object_type);
	boxes_display_set_config ((BoxesDisplay*) self, config);
	_tmp0_ = g_strdup (user);
	_g_free0 (self->priv->user);
	self->priv->user = _tmp0_;
	_tmp1_ = g_strdup (host);
	_g_free0 (self->priv->host);
	self->priv->host = _tmp1_;
	self->priv->port = port;
	_tmp2_ = self->priv->display;
	_tmp3_ = self->priv->saved_properties;
	_tmp3__length1 = self->priv->saved_properties_length1;
	boxes_box_config_save_properties (config, (GObject*) _tmp2_, _tmp3_, (gint) _tmp3__length1);
	return self;
}

BoxesSshDisplay*
boxes_ssh_display_new (BoxesBoxConfig* config,
                       const gchar* host,
                       gint port,
                       const gchar* user)
{
	return boxes_ssh_display_construct (BOXES_TYPE_SSH_DISPLAY, config, host, port, user);
}

BoxesSshDisplay*
boxes_ssh_display_construct_with_uri (GType object_type,
                                      BoxesBoxConfig* config,
                                      const gchar* _uri,
                                      GError** error)
{
	BoxesSshDisplay * self = NULL;
	xmlURI* uri = NULL;
	xmlURI* _tmp0_;
	xmlURI* _tmp1_;
	const gchar* _tmp2_;
	xmlURI* _tmp4_;
	const gchar* _tmp5_;
	xmlURI* _tmp7_;
	const gchar* _tmp8_;
	xmlURI* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	xmlURI* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gint _tmp15_ = 0;
	xmlURI* _tmp16_;
	VteTerminal* _tmp18_;
	BoxesBoxConfigSavedProperty* _tmp19_;
	gint _tmp19__length1;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (config != NULL, NULL);
	g_return_val_if_fail (_uri != NULL, NULL);
	self = (BoxesSshDisplay*) boxes_display_construct (object_type);
	boxes_display_set_config ((BoxesDisplay*) self, config);
	_tmp0_ = xmlParseURI (_uri);
	uri = _tmp0_;
	_tmp1_ = uri;
	_tmp2_ = _tmp1_->scheme;
	if (g_strcmp0 (_tmp2_, "ssh") != 0) {
		GError* _tmp3_;
		_tmp3_ = g_error_new_literal (BOXES_ERROR, BOXES_ERROR_INVALID, "the URL is not ssh://");
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == BOXES_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_xmlFreeURI0 (uri);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_xmlFreeURI0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = uri;
	_tmp5_ = _tmp4_->server;
	if (_tmp5_ == NULL) {
		GError* _tmp6_;
		_tmp6_ = g_error_new_literal (BOXES_ERROR, BOXES_ERROR_INVALID, "the URL is missing a server");
		_inner_error0_ = _tmp6_;
		if (_inner_error0_->domain == BOXES_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_xmlFreeURI0 (uri);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_xmlFreeURI0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp7_ = uri;
	_tmp8_ = _tmp7_->server;
	_tmp9_ = uri;
	_tmp10_ = _tmp9_->path;
	_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
	_g_free0 (self->priv->host);
	self->priv->host = _tmp11_;
	_tmp12_ = uri;
	_tmp13_ = _tmp12_->user;
	_tmp14_ = g_strdup (_tmp13_);
	_g_free0 (self->priv->user);
	self->priv->user = _tmp14_;
	_tmp16_ = uri;
	if (_tmp16_->port <= 0) {
		_tmp15_ = 22;
	} else {
		xmlURI* _tmp17_;
		_tmp17_ = uri;
		_tmp15_ = _tmp17_->port;
	}
	self->priv->port = _tmp15_;
	_tmp18_ = self->priv->display;
	_tmp19_ = self->priv->saved_properties;
	_tmp19__length1 = self->priv->saved_properties_length1;
	boxes_box_config_save_properties (config, (GObject*) _tmp18_, _tmp19_, (gint) _tmp19__length1);
	_xmlFreeURI0 (uri);
	return self;
}

BoxesSshDisplay*
boxes_ssh_display_new_with_uri (BoxesBoxConfig* config,
                                const gchar* _uri,
                                GError** error)
{
	return boxes_ssh_display_construct_with_uri (BOXES_TYPE_SSH_DISPLAY, config, _uri, error);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
boxes_ssh_display_real_get_display (BoxesDisplay* base,
                                    gint n)
{
	BoxesSshDisplay * self;
	VteTerminal* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result = NULL;
	self = (BoxesSshDisplay*) base;
	_tmp0_ = self->priv->display;
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
	result = _tmp1_;
	return result;
}

static void
boxes_ssh_display_real_set_enable_audio (BoxesDisplay* base,
                                         gboolean enable)
{
	BoxesSshDisplay * self;
	self = (BoxesSshDisplay*) base;
}

static GdkPixbuf*
boxes_ssh_display_real_get_pixbuf (BoxesDisplay* base,
                                   gint n,
                                   GError** error)
{
	BoxesSshDisplay * self;
	GdkPixbuf* result = NULL;
	self = (BoxesSshDisplay*) base;
	result = NULL;
	return result;
}

static gboolean
boxes_ssh_display_run (BoxesSshDisplay* self,
                       gchar** command,
                       gint command_length1)
{
	GSpawnFlags flags = 0U;
	gboolean _tmp0_ = FALSE;
	VteTerminal* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	flags = G_SPAWN_SEARCH_PATH_FROM_ENVP | G_SPAWN_DO_NOT_REAP_CHILD;
	_tmp1_ = self->priv->display;
	_tmp2_ = g_get_home_dir ();
	_tmp0_ = vte_terminal_spawn_sync (_tmp1_, VTE_PTY_DEFAULT, _tmp2_, command, NULL, flags, NULL, NULL, NULL, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp3_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp3_;
	}
	result = _tmp0_;
	return result;
}

static void
boxes_ssh_display_real_connect_it (BoxesDisplay* base,
                                   BoxesDisplayOpenFDFunc open_fd,
                                   gpointer open_fd_target,
                                   GDestroyNotify open_fd_target_destroy_notify,
                                   GError** error)
{
	BoxesSshDisplay * self;
	VteTerminal* _tmp0_;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* prefix = NULL;
	gchar* _tmp6_;
	gchar** ssh_connect_cmd = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gint ssh_connect_cmd_length1;
	gint _ssh_connect_cmd_size_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	self = (BoxesSshDisplay*) base;
	if (((BoxesDisplay*) self)->connected) {
		(open_fd_target_destroy_notify == NULL) ? NULL : (open_fd_target_destroy_notify (open_fd_target), NULL);
		open_fd = NULL;
		open_fd_target = NULL;
		open_fd_target_destroy_notify = NULL;
		return;
	}
	((BoxesDisplay*) self)->connected = TRUE;
	_tmp0_ = self->priv->display;
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
	_tmp2_ = self->priv->user;
	if (g_strcmp0 (_tmp2_, "") != 0) {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = self->priv->user;
		_tmp4_ = g_strconcat (_tmp3_, "@", NULL);
		_g_free0 (_tmp1_);
		_tmp1_ = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("");
		_g_free0 (_tmp1_);
		_tmp1_ = _tmp5_;
	}
	_tmp6_ = g_strdup (_tmp1_);
	prefix = _tmp6_;
	_tmp7_ = g_strdup ("ssh");
	_tmp8_ = g_strdup_printf ("%i", self->priv->port);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat ("-p ", _tmp9_, NULL);
	_tmp11_ = prefix;
	_tmp12_ = self->priv->host;
	_tmp13_ = g_strconcat (_tmp11_, _tmp12_, NULL);
	_tmp14_ = g_new0 (gchar*, 3 + 1);
	_tmp14_[0] = _tmp7_;
	_tmp14_[1] = _tmp10_;
	_tmp14_[2] = _tmp13_;
	_tmp15_ = _tmp14_;
	_tmp15__length1 = 3;
	_g_free0 (_tmp9_);
	ssh_connect_cmd = _tmp15_;
	ssh_connect_cmd_length1 = _tmp15__length1;
	_ssh_connect_cmd_size_ = ssh_connect_cmd_length1;
	_tmp16_ = ssh_connect_cmd;
	_tmp16__length1 = ssh_connect_cmd_length1;
	boxes_ssh_display_run (self, _tmp16_, (gint) _tmp16__length1);
	ssh_connect_cmd = (_vala_array_free (ssh_connect_cmd, ssh_connect_cmd_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (prefix);
	_g_free0 (_tmp1_);
	(open_fd_target_destroy_notify == NULL) ? NULL : (open_fd_target_destroy_notify (open_fd_target), NULL);
	open_fd = NULL;
	open_fd_target = NULL;
	open_fd_target_destroy_notify = NULL;
}

static void
boxes_ssh_display_real_disconnect_it (BoxesDisplay* base)
{
	BoxesSshDisplay * self;
	self = (BoxesSshDisplay*) base;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static GList*
boxes_ssh_display_real_get_properties (BoxesDisplay* base,
                                       BoxesPropertiesPage page)
{
	BoxesSshDisplay * self;
	GList* list = NULL;
	GList* result = NULL;
	self = (BoxesSshDisplay*) base;
	list = NULL;
	result = list;
	return result;
}

static void
boxes_ssh_display_real_send_keys (BoxesDisplay* base,
                                  guint* keyvals,
                                  gint keyvals_length1)
{
	BoxesSshDisplay * self;
	self = (BoxesSshDisplay*) base;
}

static const gchar*
boxes_ssh_display_real_get_protocol (BoxesDisplay* base)
{
	const gchar* result;
	BoxesSshDisplay* self;
	self = (BoxesSshDisplay*) base;
	result = "SSH";
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gchar*
boxes_ssh_display_real_get_uri (BoxesDisplay* base)
{
	gchar* result;
	BoxesSshDisplay* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	self = (BoxesSshDisplay*) base;
	_tmp0_ = self->priv->user;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = self->priv->host;
	_tmp3_ = string_to_string (_tmp2_);
	_tmp4_ = g_strconcat ("ssh://", _tmp1_, "@", _tmp3_, NULL);
	result = _tmp4_;
	return result;
}

static void
_boxes_ssh_display___lambda88_ (BoxesSshDisplay* self)
{
	g_signal_emit_by_name ((BoxesDisplay*) self, "show", 0);
	boxes_display_access_start ((BoxesDisplay*) self);
}

static void
__boxes_ssh_display___lambda88__gtk_widget_show (GtkWidget* _sender,
                                                 gpointer self)
{
	_boxes_ssh_display___lambda88_ ((BoxesSshDisplay*) self);
}

static GObject *
boxes_ssh_display_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BoxesSshDisplay * self;
	gchar* _tmp0_;
	GValue _tmp1_ = {0};
	BoxesBoxConfigSavedProperty _tmp2_ = {0};
	BoxesBoxConfigSavedProperty* _tmp3_;
	VteTerminal* _tmp4_;
	VteTerminal* _tmp5_;
	parent_class = G_OBJECT_CLASS (boxes_ssh_display_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplay);
	_tmp0_ = g_strdup ("read-only");
	g_value_init (&_tmp1_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp1_, FALSE);
	memset (&_tmp2_, 0, sizeof (BoxesBoxConfigSavedProperty));
	_g_free0 (_tmp2_.name);
	_tmp2_.name = _tmp0_;
	G_IS_VALUE (&_tmp2_.default_value) ? (g_value_unset (&_tmp2_.default_value), NULL) : NULL;
	_tmp2_.default_value = _tmp1_;
	_tmp3_ = g_new0 (BoxesBoxConfigSavedProperty, 1);
	_tmp3_[0] = _tmp2_;
	self->priv->saved_properties = (_vala_BoxesBoxConfigSavedProperty_array_free (self->priv->saved_properties, self->priv->saved_properties_length1), NULL);
	self->priv->saved_properties = _tmp3_;
	self->priv->saved_properties_length1 = 1;
	self->priv->_saved_properties_size_ = self->priv->saved_properties_length1;
	_tmp4_ = (VteTerminal*) vte_terminal_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->display);
	self->priv->display = _tmp4_;
	_tmp5_ = self->priv->display;
	g_signal_connect_object ((GtkWidget*) _tmp5_, "show", (GCallback) __boxes_ssh_display___lambda88__gtk_widget_show, self, 0);
	return obj;
}

static void
boxes_ssh_display_class_init (BoxesSshDisplayClass * klass,
                              gpointer klass_data)
{
	boxes_ssh_display_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BoxesSshDisplay_private_offset);
	((BoxesDisplayClass *) klass)->get_display = (GtkWidget* (*) (BoxesDisplay*, gint)) boxes_ssh_display_real_get_display;
	((BoxesDisplayClass *) klass)->set_enable_audio = (void (*) (BoxesDisplay*, gboolean)) boxes_ssh_display_real_set_enable_audio;
	((BoxesDisplayClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (BoxesDisplay*, gint, GError**)) boxes_ssh_display_real_get_pixbuf;
	((BoxesDisplayClass *) klass)->connect_it = (void (*) (BoxesDisplay*, BoxesDisplayOpenFDFunc, gpointer, GDestroyNotify, GError**)) boxes_ssh_display_real_connect_it;
	((BoxesDisplayClass *) klass)->disconnect_it = (void (*) (BoxesDisplay*)) boxes_ssh_display_real_disconnect_it;
	((BoxesDisplayClass *) klass)->get_properties = (GList* (*) (BoxesDisplay*, BoxesPropertiesPage)) boxes_ssh_display_real_get_properties;
	((BoxesDisplayClass *) klass)->send_keys = (void (*) (BoxesDisplay*, guint*, gint)) boxes_ssh_display_real_send_keys;
	BOXES_DISPLAY_CLASS (klass)->get_protocol = boxes_ssh_display_real_get_protocol;
	BOXES_DISPLAY_CLASS (klass)->get_uri = boxes_ssh_display_real_get_uri;
	G_OBJECT_CLASS (klass)->get_property = _vala_boxes_ssh_display_get_property;
	G_OBJECT_CLASS (klass)->constructor = boxes_ssh_display_constructor;
	G_OBJECT_CLASS (klass)->finalize = boxes_ssh_display_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_SSH_DISPLAY_PROTOCOL_PROPERTY, boxes_ssh_display_properties[BOXES_SSH_DISPLAY_PROTOCOL_PROPERTY] = g_param_spec_string ("protocol", "protocol", "protocol", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_SSH_DISPLAY_URI_PROPERTY, boxes_ssh_display_properties[BOXES_SSH_DISPLAY_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
boxes_ssh_display_instance_init (BoxesSshDisplay * self,
                                 gpointer klass)
{
	gchar* _tmp0_;
	self->priv = boxes_ssh_display_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->priv->user = _tmp0_;
}

static void
boxes_ssh_display_finalize (GObject * obj)
{
	BoxesSshDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplay);
	_g_object_unref0 (self->priv->display);
	_g_free0 (self->priv->host);
	_g_free0 (self->priv->user);
	self->priv->saved_properties = (_vala_BoxesBoxConfigSavedProperty_array_free (self->priv->saved_properties, self->priv->saved_properties_length1), NULL);
	G_OBJECT_CLASS (boxes_ssh_display_parent_class)->finalize (obj);
}

static GType
boxes_ssh_display_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoxesSshDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_ssh_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesSshDisplay), 0, (GInstanceInitFunc) boxes_ssh_display_instance_init, NULL };
	GType boxes_ssh_display_type_id;
	boxes_ssh_display_type_id = g_type_register_static (BOXES_TYPE_DISPLAY, "BoxesSshDisplay", &g_define_type_info, 0);
	BoxesSshDisplay_private_offset = g_type_add_instance_private (boxes_ssh_display_type_id, sizeof (BoxesSshDisplayPrivate));
	return boxes_ssh_display_type_id;
}

GType
boxes_ssh_display_get_type (void)
{
	static volatile gsize boxes_ssh_display_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_ssh_display_type_id__volatile)) {
		GType boxes_ssh_display_type_id;
		boxes_ssh_display_type_id = boxes_ssh_display_get_type_once ();
		g_once_init_leave (&boxes_ssh_display_type_id__volatile, boxes_ssh_display_type_id);
	}
	return boxes_ssh_display_type_id__volatile;
}

static void
_vala_boxes_ssh_display_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	BoxesSshDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_SSH_DISPLAY, BoxesSshDisplay);
	switch (property_id) {
		case BOXES_SSH_DISPLAY_PROTOCOL_PROPERTY:
		g_value_set_string (value, boxes_display_get_protocol ((BoxesDisplay*) self));
		break;
		case BOXES_SSH_DISPLAY_URI_PROPERTY:
		g_value_take_string (value, boxes_display_get_uri ((BoxesDisplay*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

